{"openapi":"3.0.0","info":{"title":"OVHcloud API specification","description":"Specification for OVHcloud API","version":"1.0","contact":{"name":"OVH","email":"api@ml.ovh.net"}},"servers":[{"url":"https://api.eu.ovhcloud.com/v2"}],"components":{"schemas":{"any":{"description":"Can be anything (text, int, bool, json, html, etc.)","example":"This is a content of any type !"},"duration":{"type":"string","description":"Duration (e.g., P1Y2M3DT4H6M9S)","example":"P1Y2M3DT4H6M9S"},"email":{"type":"string","description":"Email address (e.g., api@ml.ovh.net)","format":"email","example":"api@ml.ovh.net"},"iam.ResourceMetadata":{"type":"object","description":"IAM resource metadata embedded in services models","properties":{"displayName":{"type":"string","description":"Resource display name","nullable":true,"readOnly":true},"id":{"type":"string","description":"Unique identifier of the resource","format":"uuid","readOnly":true},"state":{"allOf":[{"$ref":"#/components/schemas/iam.ResourceMetadata.StateEnum"}],"description":"Resource state","nullable":true,"readOnly":true},"tags":{"type":"object","description":"Resource tags. Tags that were internally computed are prefixed with ovh:","nullable":true,"additionalProperties":{"type":"string"},"readOnly":true},"urn":{"type":"string","description":"Unique resource name used in policies","readOnly":true}}},"iam.ResourceMetadata.StateEnum":{"type":"string","description":"Resource state","enum":["EXPIRED","IN_CREATION","OK","SUSPENDED"]},"iam.resource.TagFilter":{"type":"object","description":"Resource tag filter","properties":{"operator":{"allOf":[{"$ref":"#/components/schemas/iam.resource.TagFilter.OperatorEnum"}],"description":"Operator to use in order to filter on the value. Defaults to `EQ`.","nullable":true,"readOnly":true},"value":{"type":"string","description":"Value to use in order to filter tags","readOnly":true}}},"iam.resource.TagFilter.OperatorEnum":{"type":"string","description":"Operator that can be used in order to filter resources tags","enum":["EQ","EXISTS","ILIKE","LIKE","NEQ","NEXISTS"]},"internationalPhoneNumber":{"type":"string","description":"International phone number","format":"phone-number"},"ip":{"type":"string","description":"IP address (e.g., 192.0.2.0)","format":"ipv4","example":"192.0.2.0"},"ipBlock":{"type":"string","description":"IP (v4 or v6) CIDR notation (e.g., 192.0.2.0/24)","format":"ip-block","example":"192.0.2.0/24"},"ipInterface":{"type":"string","description":"IP address (e.g., 192.0.2.0)","format":"ipv4","example":"192.0.2.0"},"ipv4":{"type":"string","description":"IPv4 address (e.g., 192.0.2.0)","format":"ipv4","example":"192.0.2.0"},"ipv4Block":{"type":"string","description":"IPv4 CIDR notation (e.g., 192.0.2.0/24)","format":"ipv4-block","example":"192.0.2.0/24"},"ipv6":{"type":"string","description":"IPv6 address (e.g., 2001:41d0:1:1994::1)","format":"ipv6","example":"2001:41d0:1:1994::1"},"ipv6Block":{"type":"string","description":"IPv6 CIDR notation (e.g., 2001:41d0::/128)","format":"ipv6-block","example":"2001:41d0::/128"},"macAddress":{"type":"string","description":"MAC address (e.g., 00:00:5e:00:53:01)","format":"mac-address","example":"00:00:5e:00:53:01"},"okms.RegionEnum":{"type":"string","description":"Region","enum":["ap-south-mum","ap-southeast-sgp","ap-southeast-syd","ca-east-bhs","ca-east-tor","eu-central-waw","eu-south-mil","eu-west-eri","eu-west-gra","eu-west-lim","eu-west-par","eu-west-rbx","eu-west-sbg"]},"okms.resource.Response":{"type":"object","description":"An OKMS service","properties":{"id":{"type":"string","description":"Unique identifier of the OKMS","format":"uuid","readOnly":true},"kmipEndpoint":{"type":"string","description":"KMS kmip API endpoint","readOnly":true},"kmipObjectCount":{"type":"integer","description":"Number of KMIP objects (non destroyed)","readOnly":true},"kmipRsaEndpoint":{"type":"string","description":"KMS kmip RSA API endpoint","nullable":true,"readOnly":true},"pciDssEnabled":{"type":"boolean","description":"Whether PCI-DSS compliance is enabled on the service","readOnly":true},"pciDssEnabledAt":{"type":"string","description":"Tells when PCI-DSS compliance was enabled","nullable":true,"format":"date-time","readOnly":true},"publicCA":{"type":"string","description":"KMS public CA (Certificate Authority)","nullable":true,"readOnly":true},"publicRsaCA":{"type":"string","description":"KMS public RSA CA (Certificate Authority)","nullable":true,"readOnly":true},"region":{"allOf":[{"$ref":"#/components/schemas/okms.RegionEnum"}],"description":"Region the key management service runs in, which is where your keys and secrets are stored","readOnly":true},"restEndpoint":{"type":"string","description":"KMS rest API endpoint","readOnly":true},"secretCount":{"type":"integer","description":"Number of secrets","readOnly":true},"secretVersionCount":{"type":"integer","description":"Number of secret versions","readOnly":true},"serviceKeyCount":{"type":"integer","description":"Number of service keys","readOnly":true},"serviceKeyCountDetails":{"allOf":[{"$ref":"#/components/schemas/okms.resource.ServiceKeyCountDetails"}],"description":"Number of service keys per protection level","readOnly":true},"swaggerEndpoint":{"type":"string","description":"KMS rest API swagger UI","readOnly":true}}},"okms.resource.ResponseWithIAM":{"type":"object","description":"An OKMS service","properties":{"iam":{"allOf":[{"$ref":"#/components/schemas/iam.ResourceMetadata"}],"description":"IAM resource metadata","nullable":true,"readOnly":true},"id":{"type":"string","description":"Unique identifier of the OKMS","format":"uuid","readOnly":true},"kmipEndpoint":{"type":"string","description":"KMS kmip API endpoint","readOnly":true},"kmipObjectCount":{"type":"integer","description":"Number of KMIP objects (non destroyed)","readOnly":true},"kmipRsaEndpoint":{"type":"string","description":"KMS kmip RSA API endpoint","nullable":true,"readOnly":true},"pciDssEnabled":{"type":"boolean","description":"Whether PCI-DSS compliance is enabled on the service","readOnly":true},"pciDssEnabledAt":{"type":"string","description":"Tells when PCI-DSS compliance was enabled","nullable":true,"format":"date-time","readOnly":true},"publicCA":{"type":"string","description":"KMS public CA (Certificate Authority)","nullable":true,"readOnly":true},"publicRsaCA":{"type":"string","description":"KMS public RSA CA (Certificate Authority)","nullable":true,"readOnly":true},"region":{"allOf":[{"$ref":"#/components/schemas/okms.RegionEnum"}],"description":"Region the key management service runs in, which is where your keys and secrets are stored","readOnly":true},"restEndpoint":{"type":"string","description":"KMS rest API endpoint","readOnly":true},"secretCount":{"type":"integer","description":"Number of secrets","readOnly":true},"secretVersionCount":{"type":"integer","description":"Number of secret versions","readOnly":true},"serviceKeyCount":{"type":"integer","description":"Number of service keys","readOnly":true},"serviceKeyCountDetails":{"allOf":[{"$ref":"#/components/schemas/okms.resource.ServiceKeyCountDetails"}],"description":"Number of service keys per protection level","readOnly":true},"swaggerEndpoint":{"type":"string","description":"KMS rest API swagger UI","readOnly":true}}},"okms.resource.ServiceKeyCountDetails":{"type":"object","description":"Number of service keys per protection level","properties":{"hsm":{"type":"integer","description":"Number of service keys with the HSM protection level","readOnly":true},"software":{"type":"integer","description":"Number of service keys with the SOFTWARE protection level","readOnly":true}}},"okms.resource.UpdateRequest":{"type":"object","description":"Request body for updating an OKMS service","properties":{"pciDssEnabled":{"type":"boolean","description":"Enable or disable PCI-DSS compliance"}}},"phoneNumber":{"type":"string","description":"Phone number","format":"phone-number"},"time":{"type":"string","description":"Time (e.g., 15:04:05)","format":"time","example":"15:04:05"}},"securitySchemes":{"oAuth2AuthCode":{"type":"oauth2","description":"Oauth2","x-client-id":"1bb9c7df371741c0","x-client-secret":"a5b4de870aca620d10fbf63cd18d205b","flows":{"authorizationCode":{"authorizationUrl":"https://auth.eu.ovhcloud.com/oauth2/authorize","tokenUrl":"https://auth.eu.ovhcloud.com/oauth2/token","scopes":{"account/all":"Manage your account","all":"Manage your whole account and all your services","services/all":"Manage your services lifecycle and billing"}}}}}},"paths":{"/okms/resource":{"get":{"operationId":"getAllOkmsServices","summary":"List OKMS services","description":"Returns the OKMS services of the account, with their region, KMIP and REST endpoints, and counts of keys, secrets and KMIP objects.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"header","name":"X-Pagination-Cursor","description":"Pagination cursor","schema":{"type":"string"}},{"in":"header","name":"X-Pagination-Size","description":"Pagination size","schema":{"type":"integer"}},{"in":"query","name":"iamTags","description":"Filter resources on IAM tags","schema":{"type":"object","additionalProperties":{"type":"array","items":{"$ref":"#/components/schemas/iam.resource.TagFilter"}}}}],"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/okms.resource.ResponseWithIAM"}},"examples":{"Simple example":{"value":[{"id":"699048b5-e49e-4869-98a6-5bae91444db1","kmipEndpoint":"example.org:5696","kmipObjectCount":5,"kmipRsaEndpoint":"example.org:5697","pciDssEnabled":false,"region":"eu-west-rbx","restEndpoint":"https://example.org","secretCount":2,"secretVersionCount":3,"serviceKeyCount":3,"serviceKeyCountDetails":{"hsm":1,"software":2},"swaggerEndpoint":"https://swagger.example.org"},{"id":"a39652b2-5e02-4fef-9d78-ae67fec4d46e","kmipEndpoint":"example.org:5696","kmipObjectCount":0,"kmipRsaEndpoint":"example.org:5697","pciDssEnabled":false,"region":"eu-west-sbg","restEndpoint":"https://example.org","secretCount":0,"secretVersionCount":0,"serviceKeyCount":1,"serviceKeyCountDetails":{"hsm":0,"software":1},"swaggerEndpoint":"https://swagger.example.org"}]}}}}}},"tags":["Resources"],"x-developer-hub-navigation":[["Manage & operate","Key and Secret Manager@@@10"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\nresult = client.get(\"/v2/okms/resource\")\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n$result = $ovh->get(\"/v2/okms/resource\");\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"okms:apiovh:resource/get","required":true}],"x-expanded-response":"OkmsResourceResponseWithIAM"}},"/okms/resource/{okmsId}":{"get":{"operationId":"getOkmsService","summary":"Get an OKMS service","description":"Returns the OKMS service with its endpoints and resource counts. Set `publicCA` to true to include the KMS public CA certificate.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"path","name":"okmsId","description":"Okms ID","required":true,"schema":{"type":"string","format":"uuid"}},{"in":"query","name":"publicCA","description":"Add KMS public CA (Certificate Authority) in the output","schema":{"type":"boolean"}}],"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/okms.resource.ResponseWithIAM"},"examples":{"Simple example":{"value":{"id":"699048b5-e49e-4869-98a6-5bae91444db1","kmipEndpoint":"example.org:5696","kmipObjectCount":5,"kmipRsaEndpoint":"example.org:5697","pciDssEnabled":false,"region":"eu-west-rbx","restEndpoint":"https://example.org","secretCount":2,"secretVersionCount":8,"serviceKeyCount":3,"serviceKeyCountDetails":{"hsm":1,"software":2},"swaggerEndpoint":"https://swagger.example.org"}}}}}}},"tags":["Resources"],"x-developer-hub-navigation":[["Manage & operate","Key and Secret Manager@@@20"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\nresult = client.get(\"/v2/okms/resource/{okmsId}\")\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n$result = $ovh->get(\"/v2/okms/resource/{okmsId}\");\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"okms:apiovh:resource/get","required":true}]},"put":{"operationId":"editOkmsService","summary":"Update an OKMS service","description":"Enables or disables PCI-DSS enforcement on the service.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"path","name":"okmsId","description":"Okms ID","required":true,"schema":{"type":"string","format":"uuid"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/okms.resource.UpdateRequest"}}}},"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/okms.resource.Response"},"examples":{"Simple example":{"value":{"id":"699048b5-e49e-4869-98a6-5bae91444db1","kmipEndpoint":"example.org:5696","kmipObjectCount":5,"kmipRsaEndpoint":"example.org:5697","pciDssEnabled":true,"pciDssEnabledAt":"2025-10-10T15:20:23.337051+01:00","region":"eu-west-rbx","restEndpoint":"https://example.org","secretCount":2,"secretVersionCount":8,"serviceKeyCount":3,"serviceKeyCountDetails":{"hsm":1,"software":2},"swaggerEndpoint":"https://swagger.example.org"}}}}}}},"tags":["Resources"],"x-developer-hub-navigation":[["Manage & operate","Key and Secret Manager@@@30"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\n# Request body type: okms.resource.UpdateRequest\nresult = client.put(\"/v2/okms/resource/{okmsId}\",\n\tpciDssEnabled = None, # Enable or disable PCI-DSS compliance (type: boolean)\n)\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n// Request body type: okms.resource.UpdateRequest\n$result = $ovh->put(\"/v2/okms/resource/{okmsId}\", array(\n\tpciDssEnabled => null, // Enable or disable PCI-DSS compliance (type: boolean)\n));\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"okms:apiovh:resource/update","required":true}]}}},"tags":[{"name":"Resources","x-tag-expanded":false,"description":"Missing description"}]}
